/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.2 Beta1 Standard
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 11.08.2009
Author  : Alexey                          
Company : Home                            
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-



// Declare your global variables here
 unsigned int DCV_displey=0, adc_data;
 
// ADC interrupt service routine
interrupt [15] void adc_isr(void)
{
 // Read the AD conversion result
 adc_data=ADCW;         
}

// Timer 0 overflow interrupt service routine
interrupt [10] void timer0_ovf_isr(void)
{
// Reinitialize Timer 0 value
TCNT0=0x64;                  

// Place your code here
ADCSRA|=0x40;
}

interrupt [9] void timer1_ovf_isr(void)
{
// Reinitialize Timer 1 value
TCNT1H=0x85;
TCNT1L=0xEE;

// Place your code here
//DCV_displey=(adc_data*5.0/1023.0*3)*10.0;
DCV_displey=456;
}

void Displey(void)
{             
// des   
PORTB=0b11111110  ;
switch (DCV_displey/100)
 {
  case 0: PORTD=0b00111111  ;
  break;
  case 1: PORTD=0b00000110  ;
  break;
  case 2: PORTD=0b01011011  ;
  break;
  case 3: PORTD=0b01001111  ;
  break;
  case 4: PORTD=0b01100110  ;
  break;
  case 5: PORTD=0b01101101  ;
  break;
  case 6: PORTD=0b01111101  ;
  break;
  case 7: PORTD=0b00000111  ;
  break;
  case 8: PORTD=0b01111111  ;
  break;
  case 9: PORTD=0b01101111  ;
 }  
 delay_ms(0)  ;     
 
 // ed   
PORTB=0b11111101  ;
switch ((DCV_displey-100*(DCV_displey/100))/10)
 {
  case 0: PORTD=0b00111111  ;
  break;
  case 1: PORTD=0b00000110  ;
  break;
  case 2: PORTD=0b01011011  ;
  break;
  case 3: PORTD=0b01001111  ;
  break;
  case 4: PORTD=0b01100110  ;
  break;
  case 5: PORTD=0b01101101  ;
  break;
  case 6: PORTD=0b01111101  ;
  break;
  case 7: PORTD=0b00000111  ;
  break;
  case 8: PORTD=0b01111111  ;
  break;
  case 9: PORTD=0b01101111  ;
 }  
 delay_ms(0)  ;  
 
 // dro   
PORTB=0b11111011  ;
switch (DCV_displey-100*(DCV_displey/100)-10*((DCV_displey-100*(DCV_displey/100))/10) )
 {
  case 0: PORTD=0b00111111  ;
  break;
  case 1: PORTD=0b00000110  ;
  break;
  case 2: PORTD=0b01011011  ;
  break;
  case 3: PORTD=0b01001111  ;
  break;
  case 4: PORTD=0b01100110  ;
  break;
  case 5: PORTD=0b01101101  ;
  break;
  case 6: PORTD=0b01111101  ;
  break;
  case 7: PORTD=0b00000111  ;
  break;
  case 8: PORTD=0b01111111  ;
  break;
  case 9: PORTD=0b01101111  ;
 }  
 delay_ms(0)  ;
 
}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State7=P State6=P State5=P State4=P State3=P State2=1 State1=1 State0=1 
PORTB=0xFF;
DDRB=0x07;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=P State5=P State4=P State3=P State2=P State1=P State0=T 
PORTC=0x7E;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=P State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTD=0x80;
DDRD=0x7F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
TCCR0=0x05;
TCNT0=0x64;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 62,500 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x04;
TCNT1H=0x85;
TCNT1L=0xEE;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: AREF pin
ADMUX=0x00  ;
ADCSRA=0x8F;          

// Global enable interrupts
#asm("sei")

while (1)
      {
       // Place your code here
       Displey();
      };
}
