/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.2 Beta1 Standard
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 11.08.2009
Author  : Alexey                          
Company : Home                            
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>          
#include <delay.h>    

#define ADC_pusk ADCSRA|=0x40
#define ADC_VREF_TYPE 0x00  
#define ind_0 PORTD=0b00111111  //0
#define ind_1 PORTD=0b00000110  //1
#define ind_2 PORTD=0b01011011  //2
#define ind_3 PORTD=0b01001111  //3
#define ind_4 PORTD=0b01100110  //4
#define ind_5 PORTD=0b01101101  //5
#define ind_6 PORTD=0b01111101  //6
#define ind_7 PORTD=0b00000111  //7
#define ind_8 PORTD=0b01111111  //8
#define ind_9 PORTD=0b01101111  //9
#define ind_des PORTB=0b11111110  // 
#define ind_ed  PORTB=0b11111101  // 
#define ind_dro PORTB=0b11111011  // 
#define pause delay_ms(0)  //   

// Declare your global variables here
 unsigned int DCV_displey=0, adc_data;
 
// ADC interrupt service routine
interrupt [ADC_INT] void adc_isr(void)
{
 // Read the AD conversion result
 adc_data=ADCW;         
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Reinitialize Timer 0 value
TCNT0=0x64;                  

// Place your code here
ADC_pusk;
}

interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Reinitialize Timer 1 value
TCNT1H=0x85;
TCNT1L=0xEE;

// Place your code here
//DCV_displey=(adc_data*5.0/1023.0*3)*10.0;
DCV_displey=456;
}

void Displey(void)
{             
// des   
ind_des;
switch (DCV_displey/100)
 {
  case 0: ind_0;
  break;
  case 1: ind_1;
  break;
  case 2: ind_2;
  break;
  case 3: ind_3;
  break;
  case 4: ind_4;
  break;
  case 5: ind_5;
  break;
  case 6: ind_6;
  break;
  case 7: ind_7;
  break;
  case 8: ind_8;
  break;
  case 9: ind_9;
 }  
 pause;     
 
 // ed   
ind_ed;
switch ((DCV_displey-100*(DCV_displey/100))/10)
 {
  case 0: ind_0;
  break;
  case 1: ind_1;
  break;
  case 2: ind_2;
  break;
  case 3: ind_3;
  break;
  case 4: ind_4;
  break;
  case 5: ind_5;
  break;
  case 6: ind_6;
  break;
  case 7: ind_7;
  break;
  case 8: ind_8;
  break;
  case 9: ind_9;
 }  
 pause;  
 
 // dro   
ind_dro;
switch (DCV_displey-100*(DCV_displey/100)-10*((DCV_displey-100*(DCV_displey/100))/10) )
 {
  case 0: ind_0;
  break;
  case 1: ind_1;
  break;
  case 2: ind_2;
  break;
  case 3: ind_3;
  break;
  case 4: ind_4;
  break;
  case 5: ind_5;
  break;
  case 6: ind_6;
  break;
  case 7: ind_7;
  break;
  case 8: ind_8;
  break;
  case 9: ind_9;
 }  
 pause;
 
}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State7=P State6=P State5=P State4=P State3=P State2=1 State1=1 State0=1 
PORTB=0xFF;
DDRB=0x07;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=P State5=P State4=P State3=P State2=P State1=P State0=T 
PORTC=0x7E;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=P State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTD=0x80;
DDRD=0x7F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
TCCR0=0x05;
TCNT0=0x64;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 62,500 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x04;
TCNT1H=0x85;
TCNT1L=0xEE;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: AREF pin
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x8F;          

// Global enable interrupts
#asm("sei")

while (1)
      {
       // Place your code here
       Displey();
      };
}